

dnl AX_CHECK_HEADER_LIB([HEADER-NAME], [LIBRARY-NAME], [FUNCTION-IN-LIB], [ACTION-IF-FOUND], [ACTION-IF-NOT-FOUND], [LIB-WEB-PAGE])
AC_DEFUN([AX_CHECK_HEADER_LIB], [
    _header_check=""
    _lib_check=""

    AC_CHECK_HEADER([$1], [_header_check="yes"], [_header_check="no"])
    AC_CHECK_LIB([$2], [$3], [_lib_check="yes"], [_lib_check="no"])
    if [test "x$_header_check" = "xyes" && test "x$_lib_check" = "xyes"] ; then
         LIBS="$LIBS -l$2"
         $4
    else
         echo "no Support for $2"
         $5
    fi
])



dnl AX_CHECK_REQUIRED_HEADER_LIB([HEADER-NAME], [LIBRARY-NAME], [FUNCTION-IN-LIB], [ACTION-IF-FOUND], [ACTION-IF-NOT-FOUND], [LIB-WEB-PAGE], [CFLAGS], [OTHER_LIBS])
AC_DEFUN([AX_CHECK_REQUIRED_HEADER_LIB], [
    _header_check=""
    _lib_check=""
    LAST_FOUND_LIB=""

    _lib_USED=""
    _header_USED=""

    for _header in $1
    do
      AC_CHECK_HEADER([${_header}], [_header_check="yes" ; _header_USED=${_header}], [_header_check="no"], $7)
      if  test "x${_header_check}" = "xyes" ; then
        break
      fi
    done
    for _check_library in $2
    do
      AC_CHECK_LIB([${_check_library}], [$3], [_lib_check="yes"; _lib_USED=${_check_library}], [_lib_check="no"], $8)
      if test "x${_lib_check}" = "xyes" ; then
        LAST_FOUND_LIB=${_lib_USED}
        break
      fi
    done
    if [test "x${_header_check}" = "xyes" && test "x${_lib_check}" = "xyes"] ; then
        m4_ifval([$4], [$4], [
         LIBS="${LIBS} -l${_lib_USED}"])
    else
        m4_ifval([$5], [$5], [
         echo "------------------"
         echo "LIBRARY $2 not found."
         echo "please install the $2-LIBRARY-package which can be found at $6"
         echo "------------------"
         exit -1])
    fi
])



dnl AX_CHECK_REQUIRED_LIB([LIBRARY-NAME], [FUNCTION-IN-LIB], [ACTION-IF-FOUND], [ACTION-IF-NOT-FOUND], [LIB-WEB-PAGE])
AC_DEFUN([AX_CHECK_REQUIRED_LIB], [
    _lib_check=""
    _found_lib=""


    for _lib in $1
    do
      AC_CHECK_LIB([$_lib], [$2], [_lib_check="yes"], [_lib_check="no"])
      if test "x$_lib_check" = "xyes" ; then
        _found_lib=$_lib
        break
      fi
    done

    if [test "x$_lib_check" = "xyes"] ; then
         LIBS="$LIBS -l$_found_lib"
         $3
    else
         echo "------------------"
         echo "LIBRARY $1 not found."
         echo "please install the $1-LIBRARY-package which can be found at $5"
         echo "------------------"
         $4
         exit -1
    fi
])




dnl AX_CHECK_QT([QTDIR], [LIBRARIES], [ACTION-IF-FOUND], [ACTION-IF-NOT-FOUND], [LIB-WEB-PAGE])
AC_DEFUN([AX_CHECK_QT], [
    _lib_check=""
    _found_lib=""
    QT_PREFIX="$1"
    QT_INCLUDE_DIRECTORY=""
    QT_LIB_DIRECTORY=""
    QT_BIN_DIRECTORY=""

    QT_COMMON_INCLUDE_DIRECTORIES="
      `ls -dr ${QT_PREFIX}/include     2>/dev/null`
      /usr/include
      `ls -dr /usr/include/qt*         2>/dev/null`
      `ls -dr /usr/lib/qt*/include     2>/dev/null`
      `ls -dr /usr/local/qt*/include   2>/dev/null`
      `ls -dr /opt/qt*/include         2>/dev/null`
      `ls -dr /Developer/qt*/include   2>/dev/null`
      `ls -dr /c/Qt/*/include          2>/dev/null`
    "

    QT_COMMON_LIB_DIRECTORIES="
      `ls -dr ${QT_PREFIX}/lib         2>/dev/null`
      /usr/lib
      `ls -dr /usr/lib/qt*             2>/dev/null`
      `ls -dr /usr/local/qt*/lib       2>/dev/null`
      `ls -dr /opt/qt*/lib             2>/dev/null`
      `ls -dr /Developer/qt*/lib       2>/dev/null`
      `ls -dr /c/Qt/*/lib              2>/dev/null`
    "

    QT_COMMON_BIN_DIRECTORIES="
      `ls -dr ${QT_PREFIX}/bin         2>/dev/null`
      /usr/bin
      `ls -dr /usr/bin/qt*             2>/dev/null`
      `ls -dr /usr/local/qt*/bin       2>/dev/null`
      `ls -dr /opt/qt*/bin             2>/dev/null`
      `ls -dr /Developer/qt*/bin       2>/dev/null`
      `ls -dr /c/Qt/*/bin              2>/dev/null`
    "

## Search in all IncludeDirectories for QT-includes
    for _qt_include_directory in ${QT_COMMON_INCLUDE_DIRECTORIES}
    do
      if test -e ${_qt_include_directory}/QtCore/QCoreApplication ; then
        QT_INCLUDE_DIRECTORY="${_qt_include_directory}"
        break
      fi
    done
    if test -n ${QT_INCLUDE_DIRECTORY} ; then
      echo "Qt-Include Directory is: ${QT_INCLUDE_DIRECTORY}"
    else
      AC_MSG_ERROR([Qt Headers not found])
    fi

## Search in all LibraryDirectories for QT-includes
    for _lib_directory in ${QT_COMMON_LIB_DIRECTORIES}
    do
      if test -e ${_lib_directory}/libQtCore.so || test -e ${_lib_directory}/libQtCore4.a || \
			test -e ${_lib_directory}/QtCore.framework ; then
        QT_LIB_DIRECTORY=${_lib_directory}
        break
	  fi
    done
    if test -n ${QT_LIB_DIRECTORY} ; then
      echo "Qt-Library Directory is: ${QT_LIB_DIRECTORY}"
    else
      AC_MSG_ERROR([Qt LIB not found])
    fi

## Search in all BINDirectories for QT-executables
    for _bin_directory in ${QT_COMMON_BIN_DIRECTORIES}
    do
      if test -e ${_bin_directory}/moc || test -e  ${_bin_directory}/moc.exe ; then
        QT_BIN_DIRECTORY=${_bin_directory}
        break
      fi
    done
    if test -n ${QT_BIN_DIRECTORY} ; then
        echo "Qt-Bin Directory is: ${QT_BIN_DIRECTORY}"
    else
        QT_BIN_DIRECTORY=${QT_PREFIX}/bin
    fi

## Setting up the Environment Variables.
    QT_LIBS=""
    QT_CXXFLAGS="-I${QT_INCLUDE_DIRECTORY}"
    LDFLAGS="${LDFLAGS} -L${QT_LIB_DIRECTORY} -Wl,-rpath -Wl,${QT_LIB_DIRECTORY}"

    CACHED_CPPFLAG=${CPPFLAGS}
    CACHED_LDFLAGS=${LDFLAGS}

    LDFLAGS="${LDFLAGS} ${QT_LDFLAGS}"
    for _lib in $2
    do
      AC_CHECK_LIB([$_lib], [main], [_lib_check="yes"], [_lib_check="no"])
      if test "x$_lib_check" = "xyes" ; then
        _found_lib=$_lib
        break
      fi
    done

    if [test "x$_lib_check" = "xyes"] ; then
         QT_LIBS="${QT_LIBS} -l$_found_lib"
         AX_CHECK_REQUIRED_LIB([QtCore QtCore4], [main],,,[http://www.trolltech.com] )
         AX_CHECK_REQUIRED_LIB([QtGui QtGui4], [main],,,[http://www.trolltech.com] )
         AX_CHECK_REQUIRED_LIB([QtOpenGL QtOpenGL4], [main],,,[http://www.trolltech.com] )

         $3
    else
         echo "------------------"
         echo "LIBRARY $2 not found.in $1"
         echo "please install the $1-LIBRARY-package which can be found at $5"
         echo "------------------"
         $4
         exit -1
    fi

    echo "QT_LIBS          = ${QT_LIBS}"
    echo "QT_CXXFLAGS      = ${QT_CXXFLAGS}"
    echo "QT_LD_FLAGS      = ${QT_LDFLAGS}"
    echo "QT_BIN_DIRECTORY = ${QT_BIN_DIRECTORY}"

    AC_SUBST([QT_LIBS])
    AC_SUBST([QT_CXXFLAGS])
    AC_SUBST([QT_LDFLAGS])

    #----------#
    # QT - MOC #
    #----------#
    AC_PATH_PROGS([QT_MOC], [moc-qt4 moc], [no], ["${QT_BIN_DIRECTORY}:${PATH}"])
      if test x${QT_MOC} = xno ; then
         AC_MSG_ERROR([QT MOC not found])
      fi
    AC_SUBST([QT_MOC])

    AC_PATH_PROG([QT_UIC], [uic], [no], ["${QT_BIN_DIRECTORY}:${PATH}"])
 #     if test x${QT_UIC} = xno ; then
 #       AC_MSG_WARN([QT UIC not found])
 #     fi
    AC_SUBST([QT_UIC])

    AC_PATH_PROG([QT_RCC], [rcc], [no], ["${QT_BIN_DIRECTORY}:${PATH}"])
#      if test x${QT_RCC} = xno ; then
#        AC_MSG_WARN([QT RCC not found])
#      fi
    AC_SUBST([QT_RCC])



    # Restore Values of CPPFLAGS and LDFLAGS
    CPPFLAGS=${CACHED_CPPFLAG}
    LDFLAGS=${CACHED_LDFLAGS}
])


dnl AX_CHECK_LUA([LUA_DIR])
AC_DEFUN([AX_CHECK_LUA], [
#dnl checking for LUA.
LUA_LIBS=
LUA_INCLUDES=
dnl Check for Lua.

LUA_INCLUDE_DIRECTORY="/usr/include"
LUA_COMMON_INCLUDE_DIRECTORIES="
      `ls -dr $1                       2>/dev/null`
      /usr/include
      `ls -dr /usr/include/lua*        2>/dev/null`
      `ls -dr /usr/lib/lua/include     2>/dev/null`
      `ls -dr /usr/local/include/lua   2>/dev/null`
      `ls -dr /opt/lua*/include        2>/dev/null`
      `ls -dr /Developer/lua*/include  2>/dev/null`
    "

  for _lua_include_directory in ${LUA_COMMON_INCLUDE_DIRECTORIES}
    do
      if test -e ${_lua_include_directory}/lua.h ; then
        LUA_INCLUDE_DIRECTORY=${_lua_include_directory}
        CPPFLAGS="${CPPFLAGS} -I${LUA_INCLUDE_DIRECTORY}"
        break
      fi
  done
    if test -n ${LUA_INCLUDE_DIRECTORY} ; then
      echo "Lua-Include Directory is: ${LUA_INCLUDE_DIRECTORY}"
    else
      AC_MSG_ERROR([Lua Headers not found])
    fi


AC_CHECK_LIB([dl], [dlopen])
AX_CHECK_REQUIRED_HEADER_LIB([lua.h], [lua lua50], [lua_open],
dnl libLUA found
     [LUA_LIBS="${LUA_LIBS} -l${LAST_FOUND_LIB}"  AX_CHECK_REQUIRED_HEADER_LIB([lualib.h], [lualib lualib50], [luaopen_base],
dnl liblualib found
      [LUA_LIBS="${LUA_LIBS} -l${LAST_FOUND_LIB}"], [LUA_LIBS="${LUA_LIBS} -llualib"],
      [http://www.lua.org],, [-llua ${LUA_LIBS} -ldl -lm])],
dnl liblua not found (download it)
       [AX_GET_INSTALL_NECESSARY_LIB([http://switch.dl.sourceforge.net/sourceforge/gtksql], [lua-5.0.tar.gz], [lua-5.0], [extern_libs/], [include/*.h lib/*.a])
       LUA_LIBS="-llualib -llua"  LUA_INCLUDES="-I$(top_build_dir)/extern_libs" ], [http://www.lua.org])

AC_SUBST([LUA_LIBS])
AC_SUBST([LUA_INCLUDES])
])





dnl AX_GET_INSTALL_NECESSARY_LIB([FTP-DIR], [DIST-FILE], [DIST-DIR], [INSTALL-DIR], [INSTALL-FILES], [CONFIG-FLAGS], [MAKE-OPTS])
AC_DEFUN([AX_GET_INSTALL_NECESSARY_LIB], [

   _get_install_FTP=$1
   _get_install_DISTFILE=$2
   _get_install_DISTDIR=$3
   _get_install_INSTALLDIR=$4
   dnl $5 is left out (inegrated bellow)
   _get_install_CONFIGFLAGS=$6
   _get_install_MAKEOPTS=$7

dnl DOWNLOADING THE FILE
   if test -f "${_get_install_DISTFILE}" ; then
     echo "${_get_install_DISTFILE} already downloaded"
   else
     echo "Getting ${_get_install_DISTFILE} from ${_get_install_FTP}/${_get_install_DISTFILE}"
     echo `wget ${_get_install_FTP}/${_get_install_DISTFILE}`
   fi

dnl UNCOMPRESS STAGE
   echo "Uncompressing ${_get_install_DISTFILE}"
   echo `tar xzvf ${_get_install_DISTFILE}`

dnl ENTER DIRECTORY AND EXECUTE CONFIGURE AND MAKE
   _get_install_PWD=`pwd`
   cd ${_get_install_DISTDIR}
dnl configure
   if test -x "configure" ; then
    ./configure ${_get_install_CONFIGFLAGS}
   fi
   make ${_get_install_MAKEOPTS}
   cd ${_get_install_PWD}

dnl INSTALL STAGE
   echo "Installing Libraries and Headers into ${_get_install_INSTALLDIR} local directory"

   mkdir -p ${_get_install_INSTALLDIR}
   for _get_install_installfile in $5
    do
     echo "copy  ${_get_install_DISTDIR}/${_get_install_installfile} to ${_get_install_INSTALLDIR}/"
     cp `ls -dr ${_get_install_DISTDIR}/${_get_install_installfile}` "${_get_install_INSTALLDIR}/"
    done

#cleaning up
  echo "rm -rf ${_get_install_DISTDIR}"
  rm -rf ${_get_install_DISTDIR}
  echo "rm ${_get_install_DISTFILE}"
  rm ${_get_install_DISTFILE}
])
