/*!
 * @file server_socket.h
 *  waits for incoming connections

 */

#ifndef _SERVER_SOCKET
#define _SERVER_SOCKET

/* include this file, it contains some default definitions */
#include "netdefs.h"


/* include base_object.h since all classes are derived from this one */
#include "base_object.h"
#include "network_socket.h"


class ServerSocket : public BaseObject
{
  public:
    ServerSocket( int port);

    virtual ~ServerSocket();

    virtual bool listen( unsigned int port ) = 0;
    virtual NetworkSocket* getNewSocket( void ) = 0;
    virtual void close() = 0;
    virtual void update() = 0;
    virtual bool isOk() { return this->bOk; };

  protected:
    bool bOk;

};

#endif
