/*!
 * @file script_method.h
 * @brief Definition of ...
*/

#ifndef _SCRIPT_METHOD_H
#define _SCRIPT_METHOD_H

#include <vector>

#include "executor/executor_lua.h"


class ScriptMethod
{
public:
  ScriptMethod();
  ~ScriptMethod();

  ScriptMethod* addMethod(const std::string& methodName, const Executor& executor);

  unsigned int size() const { return methods.size(); };

  const std::string& name(unsigned int methodNumber) const { return methods[methodNumber].name; };
  const Executor* executor(unsigned int methodNumber) const { return methods[methodNumber].executor; };


private:
  struct Method
  {
    Method(const std::string& name, const Executor& executor);
    std::string    name;
    Executor*      executor;
  };

  std::vector<Method> methods;
};

#endif /* _SCRIPT_METHOD_H */
